#version 150
precision highp float;
#define DIRECTION_NONE 0
#define DIRECTION_HORIZONTAL 1
#define DIRECTION_VERTICAL 2

uniform sampler2D colorTexture;
uniform int operationMode; // samplingDirection;
//uniform float sampleSizeX;
//uniform float sampleSizeY;
uniform vec2 sampleSize;

in vec2 colorTexUV;

out vec4 fragColor;

vec4 gauss(sampler2D yColorTexture, vec2 yUV, float yDD, int yDirection)
{
	//Initialisierungen
	float wights[7];
		wights[0] = 0.015625;
		wights[1] = 0.09375;
		wights[2] = 0.234375;
		wights[3] = 0.3125;
		wights[4] = 0.234375;
		wights[5] = 0.09375;
		wights[6] = 0.015625;
	
	vec2 offsets[7];
	if(yDirection == DIRECTION_HORIZONTAL)
	{
		offsets[0] = vec2(yDD*-3.0, 0.0);
		offsets[1] = vec2(yDD*-2.0, 0.0);
		offsets[2] = vec2(yDD*-1.0, 0.0);
		offsets[3] = vec2(0.0, 0.0);
		offsets[4] = vec2(yDD*1.0, 0.0);
		offsets[5] = vec2(yDD*2.0, 0.0);
		offsets[6] = vec2(yDD*3.0, 0.0);
	}
	else //  DIRECTION_VERTICAL
	{
		offsets[0] = vec2(0.0, yDD*-3.0);
		offsets[1] = vec2(0.0, yDD*-2.0);
		offsets[2] = vec2(0.0, yDD*-1.0);
		offsets[3] = vec2(0.0, 0.0);
		offsets[4] = vec2(0.0, yDD*1.0);
		offsets[5] = vec2(0.0, yDD*2.0);
		offsets[6] = vec2(0.0, yDD*3.0);
	}

	vec4 outp = vec4(0.0, 0.0, 0.0, 0.0);

	// colorTexturen auslesen
	vec4 tempColor; 
	for(int i=0; i<7; i++)
	{
		tempColor = texture2D(yColorTexture, yUV + offsets[i]);
		outp += wights[i] * tempColor;
	}
	
	return outp;
}

void main()
{
	if(operationMode == DIRECTION_NONE)
	{
		fragColor = texture2D(colorTexture, colorTexUV);
	}
	else if(operationMode == DIRECTION_HORIZONTAL)
	{
		fragColor = gauss(colorTexture, colorTexUV, sampleSize.x, operationMode);
	}
	else
	{
		fragColor = gauss(colorTexture, colorTexUV, sampleSize.y, operationMode);
	}
	//fragColor.b = fragColor.b + 0.5f;
	//fragColor = vec4(1.0f, 0.0f, 0.0f, 1.0f); //vec4(texCoord0.x, texCoord0.y, 0.0f, 1.0f);
}