#version 410
precision highp float;

//#define COLOR_TEST 1

layout(quads, equal_spacing, ccw) in; //triangles, fractional_odd_spacing, ccw) in; fractional_even_spacing

uniform sampler2D shadowMap;
uniform mat4 cameraMatrix;
uniform mat4 inverseLightCameraMatrix;
uniform vec2 nearAndFarPlane; // near and far plane for light
uniform vec3 lightWorldPos;
uniform vec3 lightDir;


//in vec4 cScreenPosition[]; // screnpostion von dem licht aus
in vec2 cTexUV[];
#ifdef COLOR_TEST
	in vec3 cTestColor[];
#endif

out vec4 eWorlPos;
#ifdef COLOR_TEST
	out vec3 eTestColor;
#endif

void main()
{
	//vec2 texUV = cTexUV[0] * gl_TessCoord.x + cTexUV[1] * gl_TessCoord.y + cTexUV[2] * gl_TessCoord.z;
	//vec4 pos = cScreenPosition[0] * gl_TessCoord.x + cScreenPosition[1] * gl_TessCoord.y + cScreenPosition[2] * gl_TessCoord.z;
	// wen kein quad: 
	float u = gl_TessCoord.x, v = gl_TessCoord.y;
	vec2 a = mix(cTexUV[0], cTexUV[1], u);
	vec2 b = mix(cTexUV[3], cTexUV[2], u);
	vec2 texUV = mix(a, b, v);
	// ich geh aber davon aus das ich lauter schne quads habe:
	//vec2 texUV = cTexUV[0] * gl_TessCoord.x + cTexUV[3] * gl_TessCoord.y;
	//vec4 pos = cScreenPosition[0] * gl_TessCoord.x + cScreenPosition[3] * gl_TessCoord.y;
	
	#ifdef COLOR_TEST
		vec3 aC = mix(cTestColor[0], cTestColor[1], u);
		vec3 bC = mix(cTestColor[3], cTestColor[2], u);
		eTestColor = mix(aC, bC, v);
	#endif

	float zDistance = texture(shadowMap, texUV.xy).r;
	//zDistance = 0.3;

	vec4 worldPos;
	if(zDistance == 0.0)
	{
		worldPos = vec4(lightWorldPos, 1.0);
		//worldPos = vec4(lightWorldPos + (lightDir * nearAndFarPlane.x * 0.5), 1.0);
	}
	else
	{
		// TODO in den vertex shader verlagern was geht!!!!!!!!!!!!!!!!!!
		// H is the viewport position at this pixel in the range -1 to 1.  
		//vec4 H = vec4(texUV.x * 2.f - 1.0f, texUV.y * 2.0f - 1.0f,  zOverW * 2.0 - 1.0, 1.0f);
		//float z = (zOverW * 2.0 - 1.0) * 
		//vec4 H = vec4(texUV.x * 2.f - 1.0f, texUV.y * 2.0f - 1.0f,  zOverW * 2.0 - 1.0, 1.0f);
		vec4 H = vec4(texUV.x * 2.f - 1.0f, texUV.y * 2.0f - 1.0f,  0.0, 1.0f);
		// Transform by the view-projection inverse.  
		vec4 worldPosOverW = inverseLightCameraMatrix * H;
		// Divide by w to get the world position.  
		vec4 worldNearPlanePos = worldPosOverW / worldPosOverW.w;

		vec3 wZDir = normalize(worldNearPlanePos.xyz - lightWorldPos);
		float worldLightRayLen = nearAndFarPlane.y * zDistance;
		worldPos = vec4(lightWorldPos + (wZDir * worldLightRayLen), 1.0);

		// licht volumen im spitz schlieen
		//if(texUV.x < 0.01 || texUV.x > 0.99
		//	|| texUV.y < 0.01 || texUV.y > 0.99)
		//worldPos = vec4(lightWorldPos, 1.0);
	}
	
	//eWorlPos = worldPosOverW;
	//gl_Position = cameraMatrix * worldPosOverW;
	eWorlPos = worldPos;

	vec4 posInCameraSpace = cameraMatrix * worldPos;
	//if (posInCameraSpace.z / posInCameraSpace.w < 0.2) //-1.0)
	//	posInCameraSpace.z = 0.2 * posInCameraSpace.w; //-posInCameraSpace.w;
	/*if (posInCameraSpace.z < -1.0) //-1.0)
	{
		posInCameraSpace.z = -1.1; // * posInCameraSpace.w; //-posInCameraSpace.w;
		//posInCameraSpace = vec4(0.0, 0.0, 0.0, 1.0);
	}*/

	gl_Position = posInCameraSpace;
	//gl_Position = vec4(texUV - 0.5, 0.0, 1.0);
}