

layout(triangles) in;

//3 vertices per tri, output 6 tris (1 for each cm-face)
layout(triangle_strip, max_vertices=18) out;

// contains P*V[i], transforms from WS to cubemap-face i
uniform mat4 CubeMapMat[6];

out vec4 wsPos; //wsPosFromGS;

void main(void)
{
	//iterate over the 6 cubemap faces
	for(gl_Layer=0; gl_Layer<6; ++gl_Layer)
	{
		for(int tri_vert=0; tri_vert<3; ++tri_vert) // glCullFace(GL_BACK);
		//for(int tri_vert=2; tri_vert>-1; --tri_vert) // glCullFace(GL_FRONT); facken ...
		{
			wsPos = gl_in[tri_vert].gl_Position;
			gl_Position = CubeMapMat[gl_Layer] * wsPos;
			EmitVertex();
		}
		EndPrimitive();
	}
}