
uniform mat4 matrix; //model matrix (passed per object)
#ifndef CUBEMAP
	uniform mat4 cameraMatrix;
#endif 

in vec3 vertex; // object space vertex positions

#ifndef CUBEMAP
	out vec4 wsPos;
#endif

void main(void)
{
	#ifdef CUBEMAP
		// transform vertex to world space
		gl_Position = matrix * vec4(vertex, 1.0);
		// in the GS the value of gl_Position can
		// be accessed like this:
		// gl_in[triangle_vertex_idx].gl_Position;
	#else
		wsPos = matrix * vec4(vertex, 1.0);
		gl_Position = cameraMatrix * wsPos;
	#endif
}

/*#ifdef BLAAAAAAA
  ...
#else
  ...
#endif
  */