#version 150
precision highp float;

uniform sampler2D depthTexture;
uniform sampler2D colorTexture;

in vec3 position;
in vec2 colorUV;

out vec4 fragColor;

void main()
{
	float alpha;
	vec2 depthUV = (position.xy + 1.0f) / 2.0f;
	float depth = texture2D(depthTexture, depthUV).r;
	
	if(gl_FragCoord.z < depth)
		alpha = 1.0f;
	else
		alpha = 0.0f;

	fragColor = texture2D(colorTexture, colorUV.xy) * alpha;
}