#version 150
precision highp float;

layout(points) in;
layout(triangle_strip, max_vertices = 6) out;

uniform vec2 billBoardSize;

out vec3 position;
out vec2 colorUV;

void main()
{	
	vec4 glpos = gl_in[0].gl_Position / gl_in[0].gl_Position.w;

	vec4 pos = glpos + vec4(-billBoardSize.x, billBoardSize.y, 0.0, 0.0);
	gl_Position = pos;
	position = pos.xyz / pos.w;
	colorUV = vec2(0.0, 1.0);
	EmitVertex();

	pos = glpos + vec4(+billBoardSize.x, -billBoardSize.y, 0.0, 0.0);
	gl_Position = pos;
	position = pos.xyz / pos.w;
	colorUV = vec2(1.0, 0.0);
	EmitVertex();

	pos = glpos + vec4(billBoardSize.x, billBoardSize.y, 0.0, 0.0);
	gl_Position = pos;
	position = pos.xyz / pos.w;
	colorUV = vec2(1.0, 1.0);
	EmitVertex();
	EndPrimitive();

	pos = glpos + vec4(-billBoardSize.x, billBoardSize.y, 0.0, 0.0);
	gl_Position = pos;
	position = pos.xyz / pos.w;
	colorUV = vec2(0.0, 1.0);
	EmitVertex();

	pos = glpos + vec4(-billBoardSize.x, -billBoardSize.y, 0.0, 0.0);
	gl_Position = pos;
	position = pos.xyz / pos.w;
	colorUV = vec2(0.0, 0.0);
	EmitVertex();

	pos = glpos + vec4(+billBoardSize.x, -billBoardSize.y, 0.0, 0.0);
	gl_Position = pos;
	position = pos.xyz / pos.w;
	colorUV = vec2(1.0, 0.0);
	EmitVertex();
	EndPrimitive();
}